#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"
#include "game/level_update.h"
#include "levels/scripts.h"
#include "actors/common1.h"
#include "make_const_nonconst.h"

#include "areas/1/custom.model.inc.h"
#include "areas/2/custom.model.inc.h"
#include "areas/3/custom.model.inc.h"
#include "levels/castle_courtyard/header.h"
extern u8 _castle_courtyard_segment_ESegmentRomStart[]; 
extern u8 _castle_courtyard_segment_ESegmentRomEnd[];
#include "levels/castle_inside/header.h"
const LevelScript level_castle_courtyard_entry[] = {
INIT_LEVEL(),
LOAD_MIO0(0x07, _castle_inside_segment_7SegmentRomStart, _castle_inside_segment_7SegmentRomEnd),
LOAD_RAW(0x1A, _castle_insideSegmentRomStart, _castle_insideSegmentRomEnd),
LOAD_RAW(0x0E, _castle_courtyard_segment_ESegmentRomStart, _castle_courtyard_segment_ESegmentRomEnd),
LOAD_MIO0(0xA,_cloud_floor_skybox_mio0SegmentRomStart,_cloud_floor_skybox_mio0SegmentRomEnd),
LOAD_MIO0(8,_common0_mio0SegmentRomStart,_common0_mio0SegmentRomEnd),
LOAD_RAW(15,_common0_geoSegmentRomStart,_common0_geoSegmentRomEnd),
LOAD_MIO0(5,_group10_mio0SegmentRomStart,_group10_mio0SegmentRomEnd),
LOAD_RAW(12,_group10_geoSegmentRomStart,_group10_geoSegmentRomEnd),
LOAD_MIO0(6,_group15_mio0SegmentRomStart,_group15_mio0SegmentRomEnd),
LOAD_RAW(13,_group15_geoSegmentRomStart,_group15_geoSegmentRomEnd),
ALLOC_LEVEL_POOL(),
MARIO(/*model*/ MODEL_MARIO, /*behParam*/ 0x00000001, /*beh*/ bhvMario),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_BOWSER_TRAP,        castle_geo_000F18),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_WATER_LEVEL_PILLAR, castle_geo_001940),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_CLOCK_MINUTE_HAND,  castle_geo_001530),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_CLOCK_HOUR_HAND,    castle_geo_001548),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_CLOCK_PENDULUM,     castle_geo_001518),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_CASTLE_DOOR,        castle_door_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_WOODEN_DOOR,        wooden_door_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_METAL_DOOR,         metal_door_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_CASTLE_DOOR_UNUSED, castle_door_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_WOODEN_DOOR_UNUSED, wooden_door_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_DOOR_0_STARS,       castle_door_0_star_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_DOOR_1_STAR,        castle_door_1_star_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_DOOR_3_STARS,       castle_door_3_stars_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_KEY_DOOR,           key_door_geo),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_STAR_DOOR_30_STARS, castle_geo_000F00),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_STAR_DOOR_8_STARS,  castle_geo_000F00),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_STAR_DOOR_50_STARS, castle_geo_000F00),
LOAD_MODEL_FROM_GEO(MODEL_CASTLE_STAR_DOOR_70_STARS, castle_geo_000F00),
LOAD_MODEL_FROM_GEO(22, warp_pipe_geo),
LOAD_MODEL_FROM_GEO(23, bubbly_tree_geo),
LOAD_MODEL_FROM_GEO(24, spiky_tree_geo),
LOAD_MODEL_FROM_GEO(25, snow_tree_geo),
LOAD_MODEL_FROM_GEO(27, palm_tree_geo),
LOAD_MODEL_FROM_GEO(28, castle_door_geo),
LOAD_MODEL_FROM_GEO(29, wooden_door_geo),
LOAD_MODEL_FROM_GEO(31, metal_door_geo),
LOAD_MODEL_FROM_GEO(32, hazy_maze_door_geo),
LOAD_MODEL_FROM_GEO(34, castle_door_0_star_geo),
LOAD_MODEL_FROM_GEO(35, castle_door_1_star_geo),
LOAD_MODEL_FROM_GEO(36, castle_door_3_stars_geo),
LOAD_MODEL_FROM_GEO(37, key_door_geo),
LOAD_MODEL_FROM_GEO(38, castle_door_geo),
LOAD_MODEL_FROM_GEO(39, wooden_door_geo),
LOAD_MODEL_FROM_GEO(41, metal_door_geo),
// LOAD_MODEL_FROM_DL(132,0x08025f08,4),
// LOAD_MODEL_FROM_DL(158,0x0302c8a0,4),
// LOAD_MODEL_FROM_DL(159,0x0302bcd0,4),
// LOAD_MODEL_FROM_DL(161,0x0301cb00,4),
// LOAD_MODEL_FROM_DL(164,0x04032a18,4),
// LOAD_MODEL_FROM_DL(201,0x080048e0,4),
// LOAD_MODEL_FROM_DL(218,0x08024bb8,4),
JUMP_LINK(script_func_global_1),
JUMP_LINK(script_func_global_11),
JUMP_LINK(script_func_global_16),
JUMP_LINK(local_area_castle_courtyard_1_),
JUMP_LINK(local_area_castle_courtyard_2_),
JUMP_LINK(local_area_castle_courtyard_3_),
FREE_LEVEL_POOL(),
MARIO_POS(1,0,0,0,0),
CALL(/*arg*/ 0, /*func*/ lvl_init_or_update),
CALL_LOOP(/*arg*/ 1, /*func*/ lvl_init_or_update),
CLEAR_LEVEL(),
SLEEP_BEFORE_EXIT(/*frames*/ 1),
EXIT(),
};
const LevelScript local_area_castle_courtyard_1_[] = {
AREA(1,Geo_castle_courtyard_1_0x14ece50),
TERRAIN(col_castle_courtyard_1_0xe011060),
SET_BACKGROUND_MUSIC(0,26),
TERRAIN_TYPE(0),
JUMP_LINK(local_objects_castle_courtyard_1_),
JUMP_LINK(local_warps_castle_courtyard_1_),
END_AREA(),
RETURN()
};
const LevelScript local_objects_castle_courtyard_1_[] = {
OBJECT_WITH_ACTS(0,0,0,0,0,0,0,0xa0000, bhvSpinAirborneWarp,31),
OBJECT_WITH_ACTS(38,-4,-122,502,0,0,0,0xb0000, bhvDoorWarp,31),
OBJECT_WITH_ACTS(0,-316,0,-285,0,0,0,0x0, bhvWarp,31),
OBJECT_WITH_ACTS(124,0,0,0,0,0,0,0x2a0000, bhvMessagePanel,31),
OBJECT_WITH_ACTS(124,0,0,-362,0,0,0,0x2b0000, bhvMessagePanel,31),
RETURN()
};
const LevelScript local_warps_castle_courtyard_1_[] = {
WARP_NODE(10,9,1,0,0),
WARP_NODE(11,26,3,1,0),
WARP_NODE(0,25,1,0,0),
WARP_NODE(240,6,1,50,0),
WARP_NODE(241,16,1,22,0),
RETURN()
};
const LevelScript local_area_castle_courtyard_2_[] = {
AREA(2,Geo_castle_courtyard_2_0x14ed030),
TERRAIN(col_castle_courtyard_2_0xe026180),
SET_BACKGROUND_MUSIC(0,12),
TERRAIN_TYPE(0),
JUMP_LINK(local_objects_castle_courtyard_2_),
JUMP_LINK(local_warps_castle_courtyard_2_),
END_AREA(),
RETURN()
};
const LevelScript local_objects_castle_courtyard_2_[] = {
OBJECT_WITH_ACTS(0,-606,0,-141,0,120,0,0xa0000, bhvSpinAirborneWarp,31),
OBJECT_WITH_ACTS(213,506,0,-404,0,135,0,0x3000000, bhvStarDoor,31),
OBJECT_WITH_ACTS(213,401,0,-508,0,315,0,0x3000000, bhvStarDoor,31),
OBJECT_WITH_ACTS(137,532,360,6,0,0,0,0x30000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(0,-640,0,120,0,0,0,0x0, bhvFadingWarp,31),
OBJECT_WITH_ACTS(0,626,0,-624,0,0,0,0x10000, bhvWarp,31),
OBJECT_WITH_ACTS(0,10,5,10,0,0,0,11, RM_Scroll_Texture,31),
RETURN()
};
const LevelScript local_warps_castle_courtyard_2_[] = {
WARP_NODE(10,9,2,0,0),
WARP_NODE(0,16,1,13,0),
WARP_NODE(1,30,1,10,0),
WARP_NODE(240,6,1,50,0),
WARP_NODE(241,16,1,24,0),
RETURN()
};
const LevelScript local_area_castle_courtyard_3_[] = {
AREA(3,Geo_castle_courtyard_3_0x14ed210),
TERRAIN(col_castle_courtyard_3_0xe079730),
SET_BACKGROUND_MUSIC(0,8),
TERRAIN_TYPE(0),
JUMP_LINK(local_objects_castle_courtyard_3_),
JUMP_LINK(local_warps_castle_courtyard_3_),
END_AREA(),
RETURN()
};
const LevelScript local_objects_castle_courtyard_3_[] = {
OBJECT_WITH_ACTS(0,984,0,727,0,250,0,0xa0000, bhvSpinAirborneWarp,31),
OBJECT_WITH_ACTS(0,1277,0,844,0,250,0,0x14000000, bhvFadingWarp,31),
OBJECT_WITH_ACTS(85,366,10,1156,0,0,0,0xa10000, bhvSMSRYoshi,31),
OBJECT_WITH_ACTS(221,229,105,-144,0,0,0,0x85000000, bhvToadMessage,31),
OBJECT_WITH_ACTS(221,220,1016,-621,0,0,0,0x86000000, bhvToadMessage,31),
OBJECT_WITH_ACTS(38,3,93,-273,0,0,0,0x2010000, bhvDoorWarp,31),
OBJECT_WITH_ACTS(124,617,4,0,0,0,0,0x040000, bhvMessagePanel, 31),
OBJECT_WITH_ACTS(124,715,4,1052,0,180,0,0x050000, bhvMessagePanel, 31),
OBJECT_WITH_ACTS(0,10,5,10,0,0,0,12, RM_Scroll_Texture,31),
RETURN()
};
const LevelScript local_warps_castle_courtyard_3_[] = {
WARP_NODE(10,26,3,10,0),
WARP_NODE(0,16,1,11,0),
WARP_NODE(1,26,1,11,0),
WARP_NODE(240,6,1,50,0),
WARP_NODE(241,16,1,22,0),
RETURN()
};
