#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"
#include "game/level_update.h"
#include "levels/scripts.h"
#include "actors/common1.h"
#include "make_const_nonconst.h"

#include "areas/1/custom.model.inc.h"
#include "levels/jrb/header.h"
extern u8 _jrb_segment_ESegmentRomStart[]; 
extern u8 _jrb_segment_ESegmentRomEnd[];
#include "levels/rr/header.h"
const LevelScript level_jrb_entry[] = {
INIT_LEVEL(),
LOAD_MIO0(0x07, _rr_segment_7SegmentRomStart, _rr_segment_7SegmentRomEnd),
LOAD_RAW(0x1A, _rrSegmentRomStart, _rrSegmentRomEnd),
LOAD_RAW(0x0E, _jrb_segment_ESegmentRomStart, _jrb_segment_ESegmentRomEnd),
LOAD_MIO0(0xA,_water_skybox_mio0SegmentRomStart,_water_skybox_mio0SegmentRomEnd),
LOAD_MIO0(8,_common0_mio0SegmentRomStart,_common0_mio0SegmentRomEnd),
LOAD_RAW(15,_common0_geoSegmentRomStart,_common0_geoSegmentRomEnd),
ALLOC_LEVEL_POOL(),
MARIO(/*model*/ MODEL_MARIO, /*behParam*/ 0x00000001, /*beh*/ bhvMario),
LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_03,           rr_geo_000660),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_04,           rr_geo_000678),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_05,           rr_geo_000690),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_06,           rr_geo_0006A8),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_07,           rr_geo_0006C0),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_08,           rr_geo_0006D8),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_09,           rr_geo_0006F0),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0A,           rr_geo_000708),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0B,           rr_geo_000720),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0C,           rr_geo_000738),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0D,           rr_geo_000758),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0E,           rr_geo_000770),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0F,           rr_geo_000788),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_10,           rr_geo_0007A0),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_11,           rr_geo_0007B8),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_12,           rr_geo_0007D0),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_13,           rr_geo_0007E8),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_14,           rr_geo_000800),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_15,           rr_geo_000818),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_16,           rr_geo_000830),
    LOAD_MODEL_FROM_GEO(MODEL_RR_SLIDING_PLATFORM,         rr_geo_0008C0),
    LOAD_MODEL_FROM_GEO(MODEL_RR_FLYING_CARPET,            rr_geo_000848),
    LOAD_MODEL_FROM_GEO(MODEL_RR_OCTAGONAL_PLATFORM,       rr_geo_0008A8),
    LOAD_MODEL_FROM_GEO(MODEL_RR_ROTATING_BRIDGE_PLATFORM, rr_geo_000878),
    LOAD_MODEL_FROM_GEO(MODEL_RR_TRIANGLE_PLATFORM,        rr_geo_0008D8),
    LOAD_MODEL_FROM_GEO(MODEL_RR_CRUISER_WING,             rr_geo_000890),
    LOAD_MODEL_FROM_GEO(MODEL_RR_SEESAW_PLATFORM,          rr_geo_000908),
    LOAD_MODEL_FROM_GEO(MODEL_RR_L_SHAPED_PLATFORM,        rr_geo_000940),
    LOAD_MODEL_FROM_GEO(MODEL_RR_SWINGING_PLATFORM,        rr_geo_000860),
    LOAD_MODEL_FROM_GEO(MODEL_RR_DONUT_PLATFORM,           rr_geo_000920),
    LOAD_MODEL_FROM_GEO(MODEL_RR_ELEVATOR_PLATFORM,        rr_geo_0008F0),
    LOAD_MODEL_FROM_GEO(MODEL_RR_TRICKY_TRIANGLES,         rr_geo_000958),
    LOAD_MODEL_FROM_GEO(MODEL_RR_TRICKY_TRIANGLES_FRAME1,  rr_geo_000970),
    LOAD_MODEL_FROM_GEO(MODEL_RR_TRICKY_TRIANGLES_FRAME2,  rr_geo_000988),
    LOAD_MODEL_FROM_GEO(MODEL_RR_TRICKY_TRIANGLES_FRAME3,  rr_geo_0009A0),
    LOAD_MODEL_FROM_GEO(MODEL_RR_TRICKY_TRIANGLES_FRAME4,  rr_geo_0009B8),
LOAD_MODEL_FROM_GEO(22, warp_pipe_geo),
LOAD_MODEL_FROM_GEO(23, bubbly_tree_geo),
LOAD_MODEL_FROM_GEO(24, spiky_tree_geo),
LOAD_MODEL_FROM_GEO(25, snow_tree_geo),
LOAD_MODEL_FROM_GEO(27, palm_tree_geo),
LOAD_MODEL_FROM_GEO(31, metal_door_geo),
LOAD_MODEL_FROM_GEO(32, hazy_maze_door_geo),
LOAD_MODEL_FROM_GEO(34, castle_door_0_star_geo),
LOAD_MODEL_FROM_GEO(35, castle_door_1_star_geo),
LOAD_MODEL_FROM_GEO(36, castle_door_3_stars_geo),
LOAD_MODEL_FROM_GEO(37, key_door_geo),
LOAD_MODEL_FROM_GEO(38, castle_door_geo),
// LOAD_MODEL_FROM_DL(132,0x08025f08,4),
// LOAD_MODEL_FROM_DL(158,0x0302c8a0,4),
// LOAD_MODEL_FROM_DL(159,0x0302bcd0,4),
// LOAD_MODEL_FROM_DL(161,0x0301cb00,4),
// LOAD_MODEL_FROM_DL(164,0x04032a18,4),
// LOAD_MODEL_FROM_DL(201,0x080048e0,4),
// LOAD_MODEL_FROM_DL(218,0x08024bb8,4),
JUMP_LINK(script_func_global_1),
JUMP_LINK(local_area_jrb_1_),
FREE_LEVEL_POOL(),
MARIO_POS(1,0,0,0,0),
CALL(/*arg*/ 0, /*func*/ lvl_init_or_update),
CALL_LOOP(/*arg*/ 1, /*func*/ lvl_init_or_update),
CLEAR_LEVEL(),
SLEEP_BEFORE_EXIT(/*frames*/ 1),
EXIT(),
};
const LevelScript local_area_jrb_1_[] = {
AREA(1,Geo_jrb_1_0x131c790),
TERRAIN(col_jrb_1_0xe02dc20),
SET_BACKGROUND_MUSIC(0,0),
TERRAIN_TYPE(0),
JUMP_LINK(local_objects_jrb_1_),
JUMP_LINK(local_warps_jrb_1_),
END_AREA(),
RETURN()
};
const LevelScript local_objects_jrb_1_[] = {
OBJECT_WITH_ACTS(0,0,-7940,-305,0,0,0,0xa0000, bhvSpinAirborneWarp,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-6280,-100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-6550,-100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-5800,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-7108,-200,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-7108,-500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-7108,-800,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-4800,-150,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-4308,-1200,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-3000,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-3909,-400,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-2901,-600,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-2308,-100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-2508,-1100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-600,-750,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-300,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,100,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,800,-950,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1460,-600,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1280,-600,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1700,-100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1600,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,2192,-300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3192,-1100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3192,-900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3192,-700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3600,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,5400,-1100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3900,-500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,4492,-300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,18,4792,-500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,5160,-1100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,4890,-1100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,5700,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,5700,-100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,6500,-600,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,6700,-400,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,7200,-200,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,6900,-1300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,7200,-900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,7980,-1500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,7770,-1500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,7560,-1500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,8000,-100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,7600,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,8000,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,7350,-2750,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,6893,-2700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,6250,-2750,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,5793,-2700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,6600,-1828,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,5500,-1828,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,5150,-2750,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,4800,-2700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-6040,-100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1670,-600,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3950,-1700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3770,-1700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3590,-1700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,2892,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,3300,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,2592,-2300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,2000,-1700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1293,-1900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1293,-2200,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,1293,-2500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,2300,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,893,-2700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,700,-2400,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,293,-2000,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-67,-2000,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-307,-2000,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-547,-2000,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-787,-2000,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,143,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-97,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-337,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-577,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-5508,-1200,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-5508,-800,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-1700,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-1800,-2450,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-3107,-2500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-3300,-2200,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-3500,-2000,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-4000,-2500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-4000,-2100,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-4880,-2300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-5060,-2300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-5270,-2300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-5708,-2000,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-5708,-2400,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-6501,-1700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-6500,-2400,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-6500,-2700,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-7800,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-6750,-2900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-7308,-1900,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-7308,-2200,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-7308,-2500,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(E_MODEL_PURPLECOIN,0,-8100,-2300,0,0,0,0x0, id_bhvPurpleCoin,31),
OBJECT_WITH_ACTS(0, 0, -7770, -2300, 0, 0, 0, 0x0, id_bhvPurpleCoinStar, 31),
OBJECT_WITH_ACTS(0,0,0,0,0,0,0,0x0, bhvPenguinRaceFinishLine,31),
OBJECT_WITH_ACTS(0,0,-6800,-1300,0,0,0,0x0, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-8100,-885,0,0,0,0x10000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-4950,-500,0,180,0,0x20000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-6050,-500,0,180,0,0x30000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-3450,-100,0,180,0,0x40000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-2000,-1300,0,0,0,0x50000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,0,-600,0,180,0,0x60000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-1750,-600,0,0,0,0x70000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-200,-100,0,180,0,0x80000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-400,-1300,0,90,0,0x90000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,2250,-1300,0,0,0,0xb0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,2550,-500,0,0,0,0xc0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,2550,-900,0,0,0,0xd0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,3900,-100,0,180,0,0xe0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,4050,-900,0,0,0,0xf0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,4740,-900,0,0,0,0x100000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,5250,-500,0,0,0,0x110000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,5950,-500,0,180,0,0x120000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,7500,-2150,0,0,0,0x130000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,3950,-2900,0,0,0,0x140000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,2050,-2100,0,0,0,0x150000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,3100,-2100,0,0,0,0x160000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,1825,-2900,0,0,0,0x170000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,750,-1700,0,180,0,0x180000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-1025,-2300,0,180,0,0x190000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-2025,-1700,0,180,0,0x1a0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-5476,-2800,0,0,0,0x1b0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-6125,-2800,0,0,0,0x1c0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-6175,-2100,0,180,0,0x1d0000, bhvWarp,31),
OBJECT_WITH_ACTS(0,0,-6950,-2100,0,180,0,0x1e0000, bhvWarp,31),
OBJECT_WITH_ACTS(137,0,7700,-1007,0,0,0,0x20000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,-5408,-1750,0,0,0,0x20000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,-6100,-800,0,0,0,0x20000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,1200,-300,0,0,0,0x20000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,-1100,-2900,0,0,0,0x20000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,3600,-2600,0,0,0,0x20000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(0,0,-8100,-1789,0,0,0,0x1f0000, bhvFadingWarp,31),
OBJECT_WITH_ACTS(137,0,-4308,-1200,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,-2901,-600,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,3900,-500,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,18,4792,-500,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,7200,-200,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,2892,-2900,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,2000,-1700,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,-1800,-2450,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(137,0,-7800,-2900,0,0,0,0xf0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(129,0,-3909,-400,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,-2308,-100,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,-2508,-1100,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,-600,-750,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,100,-1300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,1600,-1300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,2192,-300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,3600,-1300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,4492,-300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,5700,-1300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,5700,-100,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,6900,-1300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,7600,-2900,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,6893,-2700,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,5793,-2700,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,4800,-2700,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,3300,-2900,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,2592,-2300,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,293,-2000,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,-6501,-1700,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,0,-4800,-150,0,0,0,0x0, bhvBreakableBox,31),
OBJECT_WITH_ACTS(0,10,5,10,0,0,0,2, RM_Scroll_Texture,31),
OBJECT_WITH_ACTS(0,10,5,10,0,0,0,3, RM_Scroll_Texture,31),
RETURN()
};
const LevelScript local_warps_jrb_1_[] = {
WARP_NODE(10,9,1,0,0),
WARP_NODE(0,12,1,1,0),
WARP_NODE(1,12,1,0,0),
WARP_NODE(2,12,1,3,0),
WARP_NODE(3,12,1,2,0),
WARP_NODE(4,12,1,5,0),
WARP_NODE(5,12,1,4,0),
WARP_NODE(6,12,1,7,0),
WARP_NODE(7,12,1,6,0),
WARP_NODE(8,12,1,9,0),
WARP_NODE(9,12,1,8,0),
WARP_NODE(11,12,1,12,0),
WARP_NODE(12,12,1,11,0),
WARP_NODE(13,12,1,14,0),
WARP_NODE(14,12,1,13,0),
WARP_NODE(15,12,1,16,0),
WARP_NODE(16,12,1,15,0),
WARP_NODE(17,12,1,18,0),
WARP_NODE(18,12,1,17,0),
WARP_NODE(19,12,1,20,0),
WARP_NODE(20,12,1,19,0),
WARP_NODE(21,12,1,22,0),
WARP_NODE(22,12,1,21,0),
WARP_NODE(23,12,1,24,0),
WARP_NODE(24,12,1,23,0),
WARP_NODE(25,12,1,26,0),
WARP_NODE(26,12,1,25,0),
WARP_NODE(27,12,1,28,0),
WARP_NODE(28,12,1,27,0),
WARP_NODE(29,12,1,30,0),
WARP_NODE(30,12,1,29,0),
WARP_NODE(31,20,1,10,0),
WARP_NODE(240,6,1,50,0),
WARP_NODE(241,16,1,23,0),
RETURN()
};
