-- name: Super Retro Land
-- description: Dive into this retro-themed environment and collect the 100 \\#7125c2\\purple coins\\#ffffff\\ in 3 different Super Mario Bros. 3 themed stages!\n\n Original romhack by \\#deb307\\LowPolySM64\\#ffffff\\ \n\n Port by \\#2d851c\\Mr.Needlemouse\\#ffffff\\ \n\n General help and fixes by \\#de8ad1\\ Sunk \\#ffffff\\ and \\#04017d\\ Isaac\\#ffffff\\
-- incompatible: romhack


SOUND_CUSTOM_TOO_BAD = audio_sample_load("SM3DL_E3_LostLife.ogg.mp3")
SOUND_PURPLE_COIN_THEME = audio_stream_load("Super Mario Galaxy - Purple Coin.mp3")
SOUND_LOW_TIME = audio_stream_load("10 seconds left.mp3")
SOUND_WARNING = audio_stream_load("nsmbwiiStarmanRunningOut.mp3")


TEX_CLOCK = get_texture_info("blue_clock")
TEX_PURPLE_COIN = get_texture_info("purplecoinhud")

gServerSettings.stayInLevelAfterStar = 1

gBehaviorValues.ToadStar1Requirement = 0
gLevelValues.metalCapDuration = 270
gLevelValues.wingCapDuration = 180
gLevelValues.vanishCapDuration = 315
gLevelValues.metalCapDurationCotmc = 1
gLevelValues.wingCapDurationTotwc = 1
gLevelValues.vanishCapDurationVcutm = 1
gLevelValues.exitCastleWarpNode = 0x0A
gLevelValues.exitCastleLevel = LEVEL_CASTLE_COURTYARD
gLevelValues.exitCastleArea = 3
gLevelValues.fixCollisionBugs = 1

gServerSettings.bubbleDeath = 1

local np0 = gNetworkPlayers[0] -- so we can access the local player's gNetworkPlayers struct from anywhere

----------------
---Funny Text---
----------------

function over_the_amount(m)
    if m.numStars >= 5 then
        djui_popup_create("Wait hold on. Looks like you have a bit more \\#deb307\\stars\\#ffffff\\ than you should... Hmm, I guess it isn't a HUGE deal... alright, go on, get outta here.", 3)
    end
end

------------------
--100% Reward :)--
------------------

ShowReward = true
for i in pairs(gActiveMods) do
    if (gActiveMods[i].incompatible ~= nil and gActiveMods[i].incompatible:find("gamemode")) and not (gActiveMods[i].name:find("Personal Star Counter EX+")) then
        ShowReward = false
    end
end

function true_ending_reward(m)
    if m.numStars >= 4 and ShowReward then
        if not gNetworkPlayers[m.playerIndex].connected then return end
        if gNetworkPlayers[m.playerIndex].currLevelNum ~= gNetworkPlayers[0].currLevelNum or gNetworkPlayers[m.playerIndex].currAreaIndex ~= gNetworkPlayers[0].currAreaIndex then return end
        m.particleFlags = m.particleFlags | PARTICLE_SPARKLES
    end
end


---------------
--2D Sections--
---------------
camera_romhack_allow_centering(0)
camera_set_romhack_override(RCO_ALL)
rom_hack_cam_set_collisions(0)

local p = gNetworkPlayers[0]
local fixcam = 0
local levels = {
    -- add levels here
    [LEVEL_BOB] = { -2, true, 0 },
    [LEVEL_WF] = { -2, true, 0 },
    [LEVEL_JRB] = { 2, true, 0 },
    [LEVEL_BOWSER_1] = { 3, true, 0 },
    [LEVEL_TOTWC] = { 2, true, 0 },
    [LEVEL_COTMC] = { 2, true, 0 },
    [LEVEL_VCUTM] = { 2, true, 0 },
    -- [LEVEL_XP] = { fixcam, x? (boolean), magic value },
}

-- prevents players from using camera buttons (left/right) and stick up/down, unless in c-up mode
---@param m MarioState
function lockbuttons(m)
    local np = gNetworkPlayers[m.playerIndex]
    if levels[np.currLevelNum] == nil then return end



    if m.controller.buttonPressed & U_CBUTTONS ~= 0 then
        m.controller.buttonPressed = m.controller.buttonPressed - U_CBUTTONS
    end
    if m.playerIndex ~= 0 then return end



    if fixcam > 0 then
        m.controller.buttonPressed = R_CBUTTONS
        fixcam = fixcam - 1
    elseif fixcam < 0 then
        m.controller.buttonPressed = L_CBUTTONS
        fixcam = fixcam + 1
    end
    m.controller.stickY = 0
    if m.controller.stickX == 0 then m.controller.stickMag = 0 end
end

function twodee(m)
    local np = gNetworkPlayers[m.playerIndex]
    if levels[np.currLevelNum] ~= nil then
        if levels[np.currLevelNum][2] then       -- if x is true,
            m.pos.x = levels[np.currLevelNum][3] -- lock x coordinate to the magic value
        else                                     -- if not,
            m.pos.z = levels[np.currLevelNum][3] -- lock z coordinate instead
        end
    end
end

function levelinit()
    if levels[p.currLevelNum] ~= nil then
        fixcam = levels[p.currLevelNum][1]
    end
end

local function change_camera_angle(CAM_ANGLE_MARIO) return false end
-- cartain actions reset the camera, so let's fix the camera after they break it
function onaction(m, action)
    local np = gNetworkPlayers[m.playerIndex]
    if m.playerIndex ~= 0 or levels[np.currLevelNum] == nil then return end
    if action == ACT_BUBBLED or m.action == ACT_BUBBLED or m.action == ACT_STAR_DANCE_NO_EXIT or action == ACT_FLYING then
        fixcam = levels[np.currLevelNum][1]
    end
    if m.action == ACT_FLYING then
        fixcam = levels[np.currLevelNum][1] - 1
    end
end

--------------------------------
--Piranha Plant Faster Respawn--
--------------------------------

---@param obj Object
local function bhv_custom_piranha_plant_loop(obj)
    if obj.oAction == PIRANHA_PLANT_ACT_WAIT_TO_RESPAWN then
        obj.oAction = PIRANHA_PLANT_ACT_RESPAWN
    end
    if obj.oAction == PIRANHA_PLANT_ACT_BITING and cur_obj_check_if_near_animation_end() ~= 0 then
        obj.oAction = PIRANHA_PLANT_ACT_STOPPED_BITING
    end
end

hook_behavior(id_bhvPiranhaPlant, OBJ_LIST_GENACTOR, false, nil, bhv_custom_piranha_plant_loop, "bhvPiranhaPlant")

-----------------
--Custom Sounds--
-----------------

p_coin_level = {
    [LEVEL_BOB] = true,
    [LEVEL_WF] = true,
    [LEVEL_JRB] = true,
}
function p_coin_music()
    if p_coin_level[gNetworkPlayers[0].currLevelNum] ~= nil then
        audio_stream_play(SOUND_PURPLE_COIN_THEME, true, 0.7)
        audio_stream_set_looping(SOUND_PURPLE_COIN_THEME, true)
    else
        audio_stream_stop(SOUND_PURPLE_COIN_THEME)
    end
end

-------------------------------
--Purple Coin Challenge Timer--
-------------------------------

local sTimerTarget = 0
local sPopupShown = 0

local timedLevels = {
    [LEVEL_BOB] = {
        timer = 240, yellow = 120, red = 30,
    },

    [LEVEL_WF] = {
        timer = 360, yellow = 180, red = 30,
    },

    [LEVEL_JRB] = {
        timer = 480, yellow = 240, red = 90,
    },
}

local function format_number(number)
    local string = tostring(number)
    if number < 10 then
        string = "0" .. string
    end
    return string
end

function on_hud_render()
    if obj_get_first_with_behavior_id(id_bhvActSelector) then return end
    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_font(FONT_MENU)

    local level = timedLevels[np0.currLevelNum]
    local timer = sTimerTarget - get_time()
    if timer < 0 then timer = 0 end

    if level then
        local r = 14
        local g = 206
        local b = 34

        if timer <= level.red then
            r = 255
            g = 0
            b = 0
        elseif timer <= level.yellow then
            r = 247
            g = 226
            b = 0
        end
        local purples = count_objects_with_behavior(get_behavior_from_id(id_bhvPurpleCoin))
        if timer <= 0 then
            gMarioStates[0].health = 0xFF
        end

        
        if  timer == 11 then
        audio_stream_play(SOUND_LOW_TIME, true, 0.7)
        end

        if purples == 0 then timer = 999999
        audio_stream_stop(SOUND_LOW_TIME)
        end
    
        

        if purples > 0 then
            local seconds = format_number(timer % 60)
            local minutes = math.floor(timer / 60)
            djui_hud_render_texture(TEX_CLOCK, 10, 35, 1, 1)
            djui_hud_set_color(r, g, b, 255)
            djui_hud_print_text(minutes .. " :" .. seconds, 35, 40, 0.5)
        end
    end
end

function on_warp_timed_levels()
    sPopupShown = 0
    if timedLevels[np0.currLevelNum] then
        local timer = timedLevels[np0.currLevelNum].timer
        djui_popup_create("\\#ffffff\\You have \\#2d851c\\" .. math.ceil(timer / 60) .. " minutes \\#ffffff\\to get all 100 \\#7125c2\\Purple coins\\#ffffff\\, Good Luck!", 3)
        sTimerTarget = get_time() + timer
    end
end

function update_timed_levels()
    if timedLevels[np0.currLevelNum] then
        local timer = sTimerTarget - get_time()
        local showMinutes = timer > 59
        local unitString = showMinutes and "minute" or "second"
        local displayNumber = showMinutes and math.ceil(timer / 60) or timer
        if displayNumber ~= 1 then unitString = unitString .. "s" end
        if sPopupShown ~= timer and (timer == timedLevels[np0.currLevelNum].yellow or timer == timedLevels[np0.currLevelNum].red) then
            djui_popup_create("You have " .. displayNumber .. " " .. unitString .. " remaining!", 3)
            audio_stream_play(SOUND_WARNING, true, 0.9)
            sPopupShown = timer
        end
    end
end



hook_event(HOOK_ON_LEVEL_INIT, on_warp_timed_levels)
hook_event(HOOK_UPDATE, update_timed_levels)

-------------
--Deathcode--
-------------


local gStateExtras = {}
for i = 0, MAX_PLAYERS - 1 do
    gStateExtras[i] = {}
    local e = gStateExtras[i]
    e.deathScale = 0
end

local gDeathActions = {
    [ACT_STANDING_DEATH] = true,
    [ACT_DEATH_ON_BACK] = true,
    [ACT_DEATH_ON_STOMACH] = true,
    [ACT_SUFFOCATION] = true,
    [ACT_ELECTROCUTION] = true,
    [ACT_QUICKSAND_DEATH] = true,
    [ACT_DROWNING] = true,
    [ACT_WATER_DEATH] = true,
    [ACT_EATEN_BY_BUBBA] = true,
    [SURFACE_DEATH_PLANE] = true,
    [ACT_LAVA_BOOST] = true
}

local textSpeed = 0
local textAlpha = 0
local textY = 0
local textBounceCount = 0
local playSoundTimer = 0
local deathTimer = -1
local deathText = ""
local deathHappening = false
local death_messages = { "TOO BAD!", "MISS!", "L BOZO" }

local function reset_death_values()
    textSpeed = 0
    textAlpha = 0
    textY = 0
    textBounceCount = 0
    playSoundTimer = 0
    deathTimer = -1
    deathText = ""
    deathHappening = false
end

local function on_death()
    local m = gMarioStates[0]
    if gDeathActions[m.action] or
        (m.floor and m.floor.type == SURFACE_DEATH_PLANE and m.pos.y < m.floorHeight + 2048) or
        ((m.action == ACT_SQUISHED or m.action == ACT_LAVA_BOOST) and m.health == 0xff) and
        not mario_can_bubble(m) then
        if not deathHappening then
            deathHappening = true
            audio_stream_stop(SOUND_PURPLE_COIN_THEME)
            deathTimer = 30
            deathText = death_messages[math.random(1, #death_messages)]
        end
    end
    return false
end



local SCALE = 0.9

local function hud_render_too()
    if deathHappening then
        djui_hud_set_resolution(RESOLUTION_N64)
        local gravity = 4
        local SCREEN_BOTTOM = djui_hud_get_screen_height() - 60
        local m = gMarioStates[0]
        textAlpha = approach_s32(textAlpha, 0xff, 0xff / 20, 0xff / 20)

        -- wait until timer has elapsed to trigger death
        if deathTimer > 0 then
            deathTimer = deathTimer - 1
        elseif deathTimer ~= -1 then
            level_trigger_warp(m, WARP_OP_DEATH)
            deathTimer = -1
        end

        textSpeed = textSpeed + gravity
        textY = textY + textSpeed

        if textY > SCREEN_BOTTOM then
            textY = SCREEN_BOTTOM
            if textBounceCount < 2 then
                textSpeed = -20 / (2 ^ textBounceCount)
                textBounceCount = textBounceCount + 1
            end
        end

        playSoundTimer = playSoundTimer + 1
        fade_volume_scale(0, 0, 15)
        if playSoundTimer == 12 then
            audio_sample_play(SOUND_CUSTOM_TOO_BAD, m.area.camera.pos, 1)
        end

        djui_hud_set_font(FONT_MENU)
        djui_hud_set_color(0xbc, 0, 0, textAlpha)
        djui_hud_print_text(deathText,
            djui_hud_get_screen_width() * 0.5 - (djui_hud_measure_text(deathText) * 0.5) * SCALE, textY, SCALE)
    end
end

--- @param m MarioState
local function mario_update_too(m)
    if m.playerIndex ~= 0 then return end
    local e = gStateExtras[m.playerIndex]

    if (m.floor.type == SURFACE_DEATH_PLANE and m.pos.y < m.floorHeight + 2048) then
        if e.deathScale > 0 then
            camera_freeze()
            e.deathScale = e.deathScale - 0.02
        else
            camera_unfreeze()
        end

        m.vel.x = 0
        m.vel.y = 0
        m.vel.z = 0

        m.marioObj.header.gfx.scale.x = e.deathScale
        m.marioObj.header.gfx.scale.y = e.deathScale
        m.marioObj.header.gfx.scale.z = e.deathScale
    else
        e.deathScale = 1
    end
    if deathHappening and (m.controller.buttonPressed & START_BUTTON) ~= 0 then
        m.controller.buttonPressed = m.controller.buttonPressed & ~START_BUTTON
    end
end

local function level_init_too()
    reset_death_values()
end

----------------------
--Custom Shell Music--
----------------------

sCurrentShellMusic = 0

function if_then_else(cond, if_true, if_false)
    if cond then return if_true end
    return if_false
end

function SEQUENCE_ARGS(priority, seqId)
    return ((priority << 8) | seqId)
end

function play_custom_shell_music()
    play_music(0, SEQUENCE_ARGS(4, 0x41 | SEQ_VARIATION), 0)
    sCurrentShellMusic = SEQUENCE_ARGS(4, 0x22 | SEQ_VARIATION)
end

function stop_custom_shell_music()
    if sCurrentShellMusic ~= 0 then
        stop_background_music(sCurrentShellMusic)
        sCurrentShellMusic = 0
    end
end

function mario_update_even_more(m)
    if (m.action & ACT_FLAG_RIDING_SHELL) ~= 0 then
        if sCurrentShellMusic == 0 then play_custom_shell_music() end
    else
        if sCurrentShellMusic ~= 0 then stop_custom_shell_music() end
    end
end

function no_fall_damage(m)
    m.peakHeight = m.pos.y
end

-----------------------
--Bowser 1 Deactivate--
-----------------------
function cutscene_skip(m)
    local np = gNetworkPlayers[0]
    if np.currLevelNum == LEVEL_BOWSER_1 and m.area.camera.cutscene == CUTSCENE_ENTER_BOWSER_ARENA then
        m.area.camera.cutscene = 0
    end
end

hook_event(HOOK_ON_CHANGE_CAMERA_ANGLE, change_camera_angle)
hook_event(HOOK_MARIO_UPDATE, cutscene_skip)
hook_event(HOOK_MARIO_UPDATE, no_fall_damage)
hook_event(HOOK_ON_DEATH, on_death)
hook_event(HOOK_ON_LEVEL_INIT, p_coin_music)
hook_event(HOOK_BEFORE_SET_MARIO_ACTION, onaction)
hook_event(HOOK_ON_LEVEL_INIT, levelinit)
hook_event(HOOK_BEFORE_MARIO_UPDATE, lockbuttons)
hook_event(HOOK_MARIO_UPDATE, twodee)
hook_event(HOOK_ON_HUD_RENDER, on_hud_render)
hook_event(HOOK_ON_HUD_RENDER, hud_render_too)
hook_event(HOOK_MARIO_UPDATE, mario_update_too)
hook_event(HOOK_ON_LEVEL_INIT, level_init_too)
hook_event(HOOK_MARIO_UPDATE, true_ending_reward)
hook_event(HOOK_ON_PLAYER_CONNECTED, over_the_amount)
hook_event(HOOK_USE_ACT_SELECT, function() return false end)
hook_event(HOOK_GET_STAR_COLLECTION_DIALOG, function() return 0 end)